import gevent.queue
import gevent.server


class Server:

    all_queues = []

    def broadcaster(self, queue):
        for data in queue:
            self.fileobj_w.write(data)
            self.fileobj_w.flush()

    def run(self, socket):
        self.fileobj_r = socket.makefile(mode='r')
        self.fileobj_w = socket.makefile(mode='w')

        own_queue = gevent.queue.Queue()
        self.all_queues.append(own_queue)
        gevent.spawn(self.broadcaster, own_queue)

        while True:
            line = self.fileobj_r.readline()
            if not line:
                break
            for q in self.all_queues:
                if q is not own_queue:
                    q.put(line)

        own_queue.put(StopIteration)
        self.all_queues.remove(own_queue)


def runner(socket, address):
    s = Server()
    s.run(socket)


server = gevent.server.StreamServer(('localhost', 4567), runner)
server.serve_forever()
